MOD = "__TuxControls__"

require("prototypes.item")

require("prototypes.custom-input")
require("prototypes.entity")
require("prototypes.recipe")
require("prototypes.sprite")
require("prototypes.technology")

local ROW_HEIGHT = 28

local extra_styles = {
  tux_property_name = {
    type = "label_style",
    width = 140,
    height = ROW_HEIGHT,
  },

  tux_editor_bool_box = {
    type = "checkbox_style",
    size = ROW_HEIGHT,
  },

  tux_editor_color_field = {
    type = "textbox_style",
    width = 40,
    height = ROW_HEIGHT,
    horizontal_align = "right",
  },

  tux_editor_color_field_red = {
    type = "textbox_style",
    parent = "tux_editor_color_field",
    font_color = {1.0, 0.0, 0.0},
  },

  tux_editor_color_field_r = {
    type = "textbox_style",
    parent = "tux_editor_color_field",
  },

  tux_editor_complex_variant = {
    type = "dropdown_style",
    padding = 0,
    width = 200 - ROW_HEIGHT - 5,
    height = ROW_HEIGHT,
  },

  tux_editor_complex_variant_button = {
    type = "button_style",
    padding = 0,
    size = ROW_HEIGHT,
  },

  tux_editor_confirm_button = {
    type = "button_style",
    parent = "confirm_button",
    height = ROW_HEIGHT,
  },

  tux_editor_integer_box = {
    type = "textbox_style",
    padding = 0,
    width = 70,
    height = ROW_HEIGHT,
  },

  tux_editor_integer_slider = {
    type = "slider_style",
    padding_top = 20,
    width = 120,
  },

  -- tux_editor_last_row = {
  --   type = "flow_style",
  --   -- horizontally_stretchable = true,
  --   horizontal_align = "right",
  -- },

  tux_editor_signal = {
    type = "button_style",
    parent = "slot_button",
    padding = 0,
    size = ROW_HEIGHT,
  },

  tux_editor_string = {
    type = "textbox_style",
    padding = 0,
    width = 200,
    height = ROW_HEIGHT,
  },

  tux_editor_variant = {
    type = "dropdown_style",
    padding = 0,
    width = 200,
    height = ROW_HEIGHT,
  },
}

local default_gui = data.raw["gui-style"].default
for k, v in pairs(extra_styles) do
  default_gui[k] = v
end
