require("decoder")
require("encoder")

function dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end

local data_i32 = MessagePack.encode_i32{
  hello = "world",
  stuff = {r = -1, g = -100, b = -123456789},
  good = {true, "BOOP", 30, 400},
}

local result = MessagePack.decode_i32(data_i32)
print(dump(result))
