local SCHEDULER_RING_BUFFER_SIZE = 600 -- 10 seconds

------------------------------------------------------------------------------------------------

Scheduler = {}

function Scheduler.global_init()
  global.jobs = global.jobs or {}
  global.num_jobs = global.num_jobs or 0

  for i = 1, SCHEDULER_RING_BUFFER_SIZE do 
    global.jobs[i] = global.jobs[i] or {}
  end
end

function Scheduler.add_job(job, delay)
  local index = (game.tick + delay) % SCHEDULER_RING_BUFFER_SIZE + 1
  table.insert(global.jobs[index], job)
end

function Scheduler.on_tick()
  local index = game.tick % SCHEDULER_RING_BUFFER_SIZE + 1
  local jobs = global.jobs[index]
  global.jobs[index] = {}

  for _, raw_entity in pairs(jobs) do -- jobs?
    local entity = Entity.from_entity(raw_entity)
    if raw_entity and entity then
      raw_entity:on_tick()
    end
  end
end

------------------------------------------------------------------------------------------------
script.on_event(defines.events.on_tick, Scheduler.on_tick)
------------------------------------------------------------------------------------------------
