------------------------------------------------------------------------------------------------

ShortwaveSourceConfigFrame = PropertyEditorFrame:derive("shorwave-source-config-frame")
ShortwaveSourceConfigFrame.caption = "Shortwave Source Settings"
ShortwaveSourceConfigFrame.properties = {
  { field = "sw_channel_icon", caption = "Channel Icon", editor = SignalEditor },
  { field = "sw_channel_id", caption = "Channel Number", editor = IntegerEditor },
  { field = "sw_wire", caption = "Wire Color", editor = ColorEditor },
}

------------------------------------------------------------------------------------------------

SignalSourceEditor = ComplexVariantEditor:derive("signal-source-editor")
SignalSourceEditor:set_variants{
  { 
    caption = "Green Wire", 
    value = "green_wire" 
  },
  { 
    caption = "Red Wire",
    value = "red_wire" 
  },
  { 
    caption = "Named Logistic Network", 
    value = "logistic_network" 
  },
  { 
    caption = "Shortwave Signal", 
    value = "shortwave", 
    editor = ShortwaveSourceConfigFrame,
  },
}

------------------------------------------------------------------------------------------------

local active_shortwave = active_when("signal_source", "shortwave")

SignalSourceExt = Extension:new()

SignalSourceExt.properties = {
  {
    name = "signal_source",
    default = "green_wire",
    caption = "Signal Source",
    editor = SignalSourceEditor,
    active = active_always,
  },

  -- logistic_network properties
  -- {
  --   name = "color",
  --   default = {r = 255, g = 255, b = 0},
  --   active = active_static_color,
  -- },

  -- shortwave properties
  {
    name = "sw_channel_icon",
    default = nil,
    active = active_shortwave,
  },
  {
    name = "sw_channel_id",
    default = 0,
    active = active_shortwave,
  },
  {
    name = "sw_wire",
    default = {r = 1, g = 2, b = 3},
    active = active_shortwave,
  },
}

------------------------------------------------------------------------------------------------
